import * as React from 'react';
import { ComponentType, LazyExoticComponent, ReactChild, ReactElement, Component, FunctionComponentElement } from 'react';

interface LazyFactory<T extends ComponentType<any>> extends LazyFactoryMeta {
    (): Promise<{
        default: T;
    }>;
}
interface LazyFactoryMeta {
    chunk?: string;
    lazyImport?: string;
    sync?: true;
}

declare function createLazy(realReact: typeof React): <T extends ComponentType<any>>(factory: LazyFactory<T>) => LazyExoticComponent<T> | (<P extends {}>(props: P, ...children: ReactChild[]) => ReactElement<{}, string | ((props: any) => ReactElement<any, any> | null) | (new (props: any) => Component<any, any, any>)> | FunctionComponentElement<{}>);

export { createLazy };
